
/' Copyright (c) 2009, 2014 by Florian Jung
   All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this
   list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.          '/




'this contains both the prefix and the path.
const prefix="../landscapes/desert/desert"


'various presets, uncomment them as needed.
/'
'hills
const skyr1=0
const skyg1=128
const skyb1=255
const skyr2=115
const skyg2=197
const skyb2=255

const landr1=124
const landg1=255
const landb1=24
const landr2=0
const landg2=255
const landb2=0
'/

'desert
const skyr1=0*0.7
const skyg1=128*0.7
const skyb1=255*0.8
const skyr2=115*0.7
const skyg2=197*0.7
const skyb2=255*0.7


const landr1=238
const landg1=227
const landb1=101
const landr2=199
const landg2=177
const landb2=98

/'
'vulcano
const skyr1=128
const skyg1=0
const skyb1=0
const skyr2=64
const skyg2=0
const skyb2=0


const landr1=196
const landg1=128
const landb1=64
const landr2=128
const landg2=80
const landb2=40
'/

const omega=10
const wmax=45
const wmin=-45
const miny=0
const maxy=200
const smooth=50
const slope_multiplier=1.5 'makes the slope of the color gradient steeper (greater than 1) or more plain (less than 1)
const shift=20 'shifts the color gradient upwards or downwards. positive numbers: more "first" color, negative: more "second" color, zero: top is exactly first color



'#define DONTSAVE
#include "file.bi"

'#define noscreenlock
#ifdef noscreenlock
#undef screenlock
#undef screenunlock
#define screenlock /''/
#define screenunlock /''/
#endif


#include once "crt.bi"
#include once "fbpng.bi"
#include once "fbgfx.bi"

#define false 0
#define true (not false)
#define equal(a,b) (((a)+10)>(b) and ((a)-10)<(b))
#define rndrange(a,b) (rnd*((b)-(a))+(a))



declare function grey (farbe as uinteger,level as double) as uinteger
declare function green  (level as integer)as uinteger
declare function sky  (level as integer)as uinteger
declare function mitnull (zahl as integer, l as integer) as string
declare sub mkline (feld() as double)
declare function finde_lokale_maxima2(feld() as double, tmp() as integer) as integer

screenres 1024,768,32
dim as fb.image ptr buf
buf=imagecreate(1024,768)
dim as double x,y,w,sum
dim as integer xx,yy,i,gipfel,g1x,g1y,g2x,g2y,ii
dim as integer bildnr
dim as double feld(0 to 1024+smooth+1)
dim as integer maximum(1 to 512)
dim as integer feld2(0 to 1024,0 to 1)
'line (0,0)-(1025,800),rgb(255,0,0),BF
'do
bildnr=0
open cons for output as #1

do while fileexists(prefix+mitnull(bildnr,4)+".png")
	bildnr+=1
loop
?#1,"starting with ";bildnr

DO
screenlock
for yy=0 to 1024
	line (0,yy)-(1024,yy),sky(yy*255/200)
next

'dim as double iii=3
dim as double iii=2.5
randomize timer
for ii=200 to 500 step 100
'iii=(6-(ii/100)-1)/2   +1
iii-=(2.5-1)/4
	mkline(feld())

  dim as double t_quer, y_quer
  dim as double sum_ty, sum_tt
  for i=0 to 1023
    y_quer+=feld(i)
    sum_ty+=i*feld(i)
    sum_tt+=i*i
  next
  t_quer=(0+1023)/2
  y_quer/=1024
  
  
  dim as double m,t,minm,mint,minx
  minm=(sum_ty-1024*t_quer*y_quer)/(sum_tt-1024*t_quer^2)
  minm*=slope_multiplier '1.5 'TODO
  
  mint=99999
  dim as double tmp(0 to 1023)
  for i =0 to 1023
    t=feld(i)-minm*i
    if mint>t then mint=t
  next
  mint+=shift '20 'TODO
	
	dim as double tempy
	for y=0 to 1023
		for t=mint-200 to 1000
			tempy=minm*y
			if tempy+t>feld(y) and tempy+t<768 then pset(y,tempy+t+ii), grey(  green( (t-(minm*minx+mint))*2  -200) ,iii)'rgb(t/4,0,0)
		next
	next
		
next
get(0,0)-(1023,767),buf
screenunlock
#IFDEF DONTSAVE
do:loop while inkey=""
#ELSE
png_save (prefix+mitnull(bildnr,4)+".png",buf)
?#1,"wrote "+prefix+mitnull(bildnr,4)+".png"
#ENDIF
bildnr+=1
LOOP while bildnr<=9999
close #1
sleep

sub mkline (feld() as double)
	dim as integer fail,xx,yy,w
	dim as double sum,x,y
	for xx=0 to 1023+smooth:feld(xx)=0:next
	do
		x=0
    y=rndrange(miny,maxy)
    w=rndrange(wmin,wmax)
		fail=false
		do
			w+=2*rnd*omega-omega
			if w>wmax then w=wmax
			if w<wmin then w=wmin
			x+=cos(w*3.141592654/180)
			y+=sin(w*3.141592654/180)
			if y>maxy or y<miny then fail=true:exit do
			xx=x
			yy=y
			if xx>=1024+smooth then exit do
			feld(xx)=y
		loop
	loop while fail
	for xx=0 to 1024
		sum=0
		for yy=xx to xx+smooth
			sum+=feld(yy)
		next
		y=sum/smooth
		feld(xx)=y
	next
end sub
function green  (level as integer)as uinteger
	if level<=0 then return rgb(landr1,landg1,landb1)
	if level>255 then return rgb(landr2,landg2,landb2)
	return rgb(landr1+(landr2-landr1)*level/256,landg1+(landg2-landg1)*level/256,landb1+(landb2-landb1)*level/256)
end function
function sky  (level as integer)as uinteger
	if level<=0 then return rgb(skyr1,skyg1,skyb1)
	if level>255 then return rgb(skyr2,skyg2,skyb2)
	return rgb(skyr1+(skyr2-skyr1)*level/256,skyg1+(skyg2-skyg1)*level/256,skyb1+(skyb2-skyb1)*level/256)
end function
function grey (farbe as uinteger,level as double) as uinteger
	dim as integer r,g,b
	r=(farbe and &h00FF0000)/&h00010000
	g=(farbe and &h0000FF00)/&h00000100
	b=(farbe and &h000000FF)
	r=((r-127)/level)+127
	g=((g-127)/level)+127
	b=((b-127)/level)+127
	return rgb(r,g,b)
end function
function mitnull (zahl as integer, l as integer) as string
	dim as string t
	t=rtrim(ltrim(str(zahl)))
	t=string(l-len(t),"0")+t
	return t
end function

function finde_lokale_maxima2(feld() as double, tmp() as integer) as integer
  dim as integer i,j,k,cnt
  
  cnt=0
  i=0
  
  'erste voraussetzung ist bei lbound immer erfüllt, da jeder wert größer als der angenommene wert -inf ist.
  for j=0+1 to 1023 'die nächsten felder abgrasen
    if feld(0)<feld(j) then 'zweite voraussetzung erfüllt! yay! wir haben ein lokales maximum gefunden!
      cnt+=1: tmp(cnt)=(0+j-1)/2
      i=j-1 'damit es dann bei i=j weitergeht
      exit for
    elseif feld(0)>feld(j) then 'zweite voraussetzung nicht erfüllt? -> kein lokales maximum, suche abbrechen.
      i=j-1 'aber bis dahin ist es alles false, da können wir uns die suche sparen
      exit for
    end if
  next
  if j=1023+1 then 'übers ende rausgesucht? es wird angenommen, dass das ende -inf ist. foo>-inf ist immer wahr
    cnt+=1: tmp(cnt)=(0+1023)/2
    goto raus:
  end if

  for i=i+1 to 1023
    if feld(i)<feld(i-1) then 'erste voraussetzung erfüllt: f_i>f_i-1
      for j=i+1 to 1023 'die nächsten felder abgrasen
        if feld(i)<feld(j) then 'zweite voraussetzung erfüllt! yay! wir haben ein lokales maximum gefunden!
          cnt+=1: tmp(cnt)=(i+j-1)/2
          i=j-1 'damit es dann bei i=j weitergeht
          exit for
        elseif feld(i)>feld(j) then 'zweite voraussetzung nicht erfüllt? -> kein lokales maximum, suche abbrechen.
          i=j-1 'aber bis dahin ist es alles false, da können wir uns die suche sparen
          exit for
        end if
      next
      if j=1023+1 then 'übers ende rausgesucht? es wird angenommen, dass das ende -inf ist. foo>-inf ist immer wahr
        cnt+=1: tmp(cnt)=(i+1023)/2
        goto raus:
      end if
    end if
  next
  
  raus:
  return cnt
end function

